#!/usr/bin/env python
# coding: utf-8


#Allow to 'hash consing' the business objects.
class Distinctor:
    def __init__(self):
        self.distinctUnderlyings = {}
        self.distinctUnderlyingReferences = {}
        self.distinctUnderlyingDefinitions = {}
    def __intern(self, dico, item):
        id = item.getIdString()
        if id in dico:
            return dico[id]
        dico[id] = item
        return item

    def internUnderlying(self, item):
        return self.__intern(self.distinctUnderlyings, item)
    def internUnderlyingReference(self, item):
        return self.__intern(self.distinctUnderlyingReferences, item)
    def internUnderlyingDefinition(self, item):
        return self.__intern(self.distinctUnderlyingDefinitions, item)




