
#!/usr/bin/env python
# coding: utf-8

from BankImplementation.PriceQuotes import evaluateQuotes

'''
To be implemented with bank specific code
'''
def getPricingCommands():
    return ["Refresh Vol", "Refresh All MarketData", "Book"]

def processPricingCommand(customCommand):
    if customCommand.command == "Book":
        #TODO: implement automatic booking into bank system
        print(" Processing dummy 'Book' command")
        return False
    elif customCommand.command == "Refresh Vol":
        #TODO: refresh of volatility then reprice if necessary
        print(" Processing dummy 'Refresh Vol' command")
        evaluateQuotes(customCommand.derivativeData)
        return True
    elif customCommand.command == "Refresh All MarketData":
        #TODO: refresh market data then reprice if necessary
        print(" Processing dummy 'Refresh All MarketData' command")
        evaluateQuotes(customCommand.derivativeData)
        return True
    return False
